#define WIN32_LEAN_AND_MEAN
#include "resource.h"

#include <windows.h>
#include <stdio.h>




const char* defconf ="Joy=p,a,a,vkDown,vkUp,vkRight,vkLeft,vkZ,vkX,vkC,vkEnter,vkSpace,vkD,vkA,a,a";
const char* keys[] = {"Down","Up","Right","Left","A","B","C","P","X","RShift","LShift"};


HINSTANCE hInst;
int i = 0;
bool isTestRun = false;
char newconf[256];


const static char* pbus_virtualkeys[256] = {
 "", "", "", "", "", "", "", "",  "vkBksp", "vkTab", "", "", "", "vkEnter", "", "", // 00-0F
 "vkShift", "vkControl", "vkAlt", "", "vkCaps", "", "", "", "", "", "", "vkEsc", "", "", "", "", // 10-1F
 "vkSpace","vkPgUp","vkPgDown","vkEnd","vkHome","vkLeft","vkUp","vkRight", "vkDown", "","","","","vkIns","vkDel","", // 20-2F
 "vk0", "vk1", "vk2", "vk3", "vk4", "vk5", "vk6", "vk7","vk8", "vk9", "", "", "", "", "", "", // 30-3F
 "", "vkA", "vkB", "vkC", "vkD", "vkE", "vkF", "vkG", "vkH",  "vkI", "vkJ", "vkK", "vkL", "vkM", "vkN", "vkO", // 40-4F
 "vkP", "vkQ", "vkR", "vkS", "vkT", "vkU", "vkV", "vkW",  "vkX", "vkY", "vkZ", "vkLWin", "vkRWin", "vkRMenu", "", "", // 50-5F
 "vkNum0","vkNum1","vkNum2","vkNum3","vkNum4","vkNum5","vkNum6","vkNum7",
 "vkNum8","vkNum9","vkMult","vkPlus","vkBkslash","vkMinus","vkDecimal","vkSlash", // 60-6F
 "vkF1", "vkF2", "vkF3", "vkF4", "vkF5", "vkF6", "vkF7", "vkF8", "vkF9", "vkF10", "vkF11", "vkF12", "", "", "", "", // 70-7F
 "","","","","","","","","","","","","","","","", //80-8f
 "","","","","","","","","","","","","","","","", //90-9f
 "vkLSh","vkRSh","vkLCtrl","vkRCtrl","vkLAlt","vkRAlt","","","","","","","","","","", //a0-af
 "","","","","","","","","","","","","","","","", //b0-bf
 "","","","","","","","","","","","","","","","", //c0-cf
 "","","","","","","","","","","","","","","","", //d0-df
 "","","","","","","","","","","","","","","","", //e0-ef
 "","","","","","","","","","","","","","","","", //f0-ff
};


BOOL CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
        case WM_INITDIALOG:
            return TRUE;

        case WM_CLOSE:
            isTestRun = false;
            EndDialog(hwndDlg, 0);
            return TRUE;

        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDC_CONFIG:
                {
                    i = 0;
                    isTestRun=true;
                    int z = sprintf(newconf, "Joy=p,a,a,");
                    while(i<11 && isTestRun)
                    {
                        MSG m;
                        SendDlgItemMessage(hwndDlg, IDC_EDIT1, WM_SETTEXT, 0, LPARAM(keys[i]));
                        Sleep(100);
                        if(PeekMessage(&m, hwndDlg, 0, 0, PM_REMOVE))
                        {
                            if (m.message == WM_KEYDOWN)
                            {
                                z += sprintf(newconf+z,"%s,", pbus_virtualkeys[m.wParam]);
                                i++;
                            }
                            TranslateMessage(&m);
                            DispatchMessage(&m);
                        }
                    }
                    z += sprintf(newconf+z,"a,a");
                    if(isTestRun)
                        SendDlgItemMessage(hwndDlg, IDC_EDIT1, WM_SETTEXT, 0, LPARAM(newconf));
                    isTestRun=false;
                }
                return TRUE;

                case IDC_DEFAULT:
                    isTestRun = false;
                    SendDlgItemMessage(hwndDlg, IDC_EDIT1, WM_SETTEXT, 0, LPARAM(defconf));
                    return TRUE;

                case IDC_OK:
                    isTestRun = false;
                    EndDialog(hwndDlg, 0);
                    return TRUE;
            }
    }
    return FALSE;
}



int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
    hInst = hInstance;
    return DialogBox(hInstance, MAKEINTRESOURCE(DLG_CONFIG), NULL, DialogProc);
}
